			ramend	equ 0xbf
			spl		equ 0x3d
			sph		equ 0x3e
			portb	equ 0x06
			ddrb	equ 0x05
			porta	equ 0x02
			ddra	equ 0x01
			tccr0a	equ 0x19
			tccr0b	equ 0x18
			ca		equ 7
			cb		equ 6
			cc		equ 5
			cd		equ 4
			ce		equ 3
			cf		equ 2
			cg		equ 1
			dp		equ 0
			an3		equ 3
			an2		equ 2
			an1		equ 1
			an0		equ 0

			rjmp	_main

_p:			cbi		portb, an3
			sbi		portb, an2
			sbi		portb, an1
			sbi		portb, an0
			cbi		porta, ca
			cbi		porta, cb
			sbi		porta, cc
			sbi		porta, cd
			cbi		porta, ce
			cbi		porta, cf
			cbi		porta, cg
			sbi		porta, dp
			rjmp	_delay

_u:			sbi		portb, an3
			cbi		portb, an2
			sbi		portb, an1
			sbi		portb, an0
			sbi		porta, ca
			cbi		porta, cb
			cbi		porta, cc
			cbi		porta, cd
			cbi		porta, ce
			cbi		porta, cf
			sbi		porta, cg
			sbi		porta, dp
			rjmp	_delay

_i:			sbi		portb, an3
			sbi		portb, an2
			cbi		portb, an1
			sbi		portb, an0
			sbi		porta, ca
			sbi		porta, cb
			sbi		porta, cc
			sbi		porta, cd
			cbi		porta, ce
			cbi		porta, cf
			sbi		porta, cg
			sbi		porta, dp
			rjmp	_delay

_e:			sbi		portb, an3
			sbi		portb, an2
			sbi		portb, an1
			cbi		portb, an0
			cbi		porta, ca
			sbi		porta, cb
			sbi		porta, cc
			cbi		porta, cd
			cbi		porta, ce
			cbi		porta, cf
			cbi		porta, cg
			cbi		porta, dp
			rjmp	_delay

			; 25 MHz => clock period 0.04 microsec
			; what we want is 60Hz freq. which means
			; 0.016 sec period = 16 millisec = 16 000 microsec.
			; dividing them we get 400 000 clock periods to wait.
			; the biggest prescaler we have is 1024,
			; which effectively makes the timer clock period
			; 1024 times longer (1024 * 0.04 = 40.96 microsec)
			; to get to this value, out timer should count to
			; 400 000 / 40.96 ~= 9765, which it obviously can't,
			; being an 8-bit timer which can only go to 255.
			; but we can divide it further if necessary from
			; the global prescaler, but for now set it to 255.
_delay:		ldi		r16, 0xff
_loop:		ldi		r17, 0b11111111
_loop2:		ldi		r18, 255
_loop3:		nop
			nop
			nop
			nop
			dec		r18
			brne	_loop3
			dec		r17
			brne	_loop2
			dec		r16
			brne	_loop
			ret

_main:		ldi		r16, ramend
			out		spl, r16
			ldi		r16, 0
			out		sph, r16

			ldi		r16, 0xff		; DDRA (cathodes) is all-output
			out		ddra, r16
			ldi		r16, 0x0f		; bits 3:0 of DDRB (anodes) are output
			out		ddrb, r16		; the rest are inputs

			ldi		r16, 0x03
			out		tccr0b, r16

_main_loop:	rcall	_p
			rcall	_u
			rcall	_i
			rcall	_e
			rjmp	_main_loop
