            SREG        equ 0x3f
            SPH         equ 0x3e
            SPL         equ 0x3d
            TIMSK       equ 0x26
            TIFR        equ 0x25
            TCCR0A      equ 0x19
            TCCR0B      equ 0x18
            TCNT0       equ 0x17
            OCR0A       equ 0x16
            OCIE0A      equ 0b00000010
            RAMEND      equ 0xBF
            sem         equ 0x40 ; first valid memory address

            rjmp        RESET               ; Address 0x0000
            reti                            ; Address 0x0001
            reti                            ; Address 0x0002
            reti                            ; Address 0x0003
            reti                            ; Address 0x0004
            reti                            ; Address 0x0005
            reti                            ; Address 0x0006
            reti                            ; Address 0x0007
            reti                            ; Address 0x0008
            rjmp        TIM0_COMPA_ISR      ; Address 0x0009
            reti                            ; Address 0x000A
            reti                            ; Address 0x000B
            reti                            ; Address 0x000C
            reti                            ; Address 0x000D
            reti                            ; Address 0x000E
            reti                            ; Address 0x000F
            reti                            ; Address 0x0010

TIM0_COMPA_ISR:
            ldi         R16, 1
            sts         sem, R16
            reti

RESET:      ; Main program start

            ; Initialize stack
            ldi         R16, 0
            out         SPH, R16
            ldi         R16, RAMEND
            out         SPL, R16
            ; reset timer value
            ldi         R16, 0
            out         TCNT0, R16
            ; set compare match value
            ldi         R16, 5
            out         OCR0A, R16
            ; activate timer 0 overflow interrupts
            ldi         R16, OCIE0A
            out         TIMSK, R16
            ; activate global interrupts
            sei
            ; configure WGM0 as CTC mode
            ldi         R16, 0b00000010
            out         TCCR0A, R16
            ; configure CS0 as clkIO/1
            ldi         R16, 0b00000001
            out         TCCR0B, R16

_poll:      lds         R16, sem
            cpi         R16, 1
            brne        _poll

            rjmp        RESET
