package avrasm;

public class AVRException extends Exception {

	private static final long serialVersionUID = 1L;

	public String    message;
	public String    node;
	public ErrorType type;
	public int       line;
	
	public AVRException(ErrorType type, String node, int line) {
		this.type = type;
		this.node = node;
		this.line = line;
		
		switch (type) {
			case TOO_MANY_COMMENTS:
				this.message = "ERROR in line " + line + ", more than 1 comment mark (;).";
				break;
			case TOO_MANY_LABELS:
				this.message = "ERROR in line " + line + ", more than 1 label mark (:).";
				break;
			case INVALID_OPERAND:
				this.message = "ERROR in line " + line + ", invalid register operand " + node;
				break;
			case INVALID_IMMEDIATE:
				this.message = "ERROR in line " + line + ", invalid immediate value " + node;
				break;
			case UNIMPLEMENTED:
				this.message = "ERROR in line " + line + ", unimplemented instruction " + node;
				break;
			case UNDEFINED_LABEL:
				this.message = "ERROR in line " + line + ", undefined destination label " + node;
				break;
			case DUPLICATE_LABEL:
				this.message = "ERROR in line " + line + ", duplicate label " + node;
				break;
			default:
				this.message = "ERROR in line " + line;
				break;
		}
	}	

	AVRException() {
		throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
	}
	
	public String getMessage() {
		return message;
	}
}
